var SettingsButton = function(imgSrc) {
	this.jq = $('<div/>')
		.css({
			position: 'absolute',
			overflow: 'hidden',
			borderRadius: 2,
			width: 44,
			height: 20,
		});
	this.back = $('<div/>')	
		.appendTo(this.jq)
		.css({
			position: 'absolute',
			width: '100%',
			height: '100%',
			cursor: 'pointer',
		});
	this.img = $('<img>')
		.appendTo(this.back)
		.attr('src', imgSrc)
		.attr('draggable', false)
		.css({
			position: 'absolute',
			width: 16,
			height: 16,
			top: 2,
			right: 0,
			userSelect: 'none',
		});
	this.animDuration = 300;
	this._finalXPercent = 0;
};

SettingsButton.prototype = {

	layoutBehindCircle: function(circleWidth) {
		var radians = -Math.PI / 3;
		var x = circleWidth / 2 + Math.cos(radians) * circleWidth / 2;
		var y = circleWidth / 2 + Math.sin(radians) * circleWidth / 2;
		var right = (circleWidth - x) - (26 + circleWidth * 0.015);
		if(right < 0) {
			right = 0;
		}
		var top = y - 8;
		if(top < 0) {
			top = 0;
		}
		var width = 48 + circleWidth * 0.015;
		var maxWidth = circleWidth / 2 - right;
		if(width >  maxWidth) {
			width = maxWidth;
		}
		this.jq.css({
			width: width,
			right: right,
			top: top,
		});
		this.img.css({
			right: 2,
		});
	},

	layoutInCorner: function() {
		this.jq.css({
			width: 24,
			right: 0,
			top: 2,
		});
		this.img.css({
			right: 4,
		});
	},

	setShown: function(val) {
		this.back.velocity('stop');
		var xPercent = val ? 0 : -100;
		this._finalXPercent = xPercent;
		this.back.css({
			left: xPercent,
		});
	},

	setShownAnim: function(val) {
		var xPercent = val ? 0 : -100;
		if(this._finalXPercent !== xPercent) {
			this._finalXPercent = xPercent;
			this.back.velocity('stop');
			this.back.velocity({
				left: xPercent + '%',
			}, {
				duration: this.animDuration,
			});
		}
	},

};
