/* Each instance of one of these represents a dice spinning animation. Easiest to use by creating a new instance for each anim. */

function DiceSpin(onEnd) {
	this._count = dice.length; //Number of dice currently spinning.
	this.onEnd = onEnd;
	this._isRunning = false;
	for(var i = 0; i < dice.length; i++) {
		this.addListener(dice[i]);
	}
}

DiceSpin.prototype = {

	isRunning: function() {
		return this._isRunning;
	},

	start: function() {
		this._isRunning = true;
		this._count = dice.length;
		var delta = getRandomArbitrary(0.5, 0.75);
		for(var i = 0; i < this._count; i++) {
			var die = dice[i];
			die.traqBall.disable();
			die.traqBall.spin(delta);
		}
	},

	_spinDone: function(die) {
		die.endSpin();
		this._count--;
		if(this._count === 0 && this.onEnd) {
			this._isRunning = false;
			this.onEnd(this);
		}
	},

	addListener: function(die) {
		var self = this;
		die.traqBall.addObserver("spinDone", function() {
			self._spinDone(die);
		});
	},

};