function DiceThemer() {
	var self = this;
	var diceThemes = {};

	function init() {
		diceThemes["Traditional"] = {
			type:"Traditional",
			content: [
				traditionalSide(1), 
				traditionalSide(3), 
				traditionalSide(2), 
				traditionalSide(6), 
				traditionalSide(5), 
				traditionalSide(4)
			],
		};
		diceThemes["Letters"] = {
			type:"Letters",
			content: [
				getLetterSpan(1,"a"), 
				getLetterSpan(2,"b"), 
				getLetterSpan(3,"c"), 
				getLetterSpan(4,"d"), 
				getLetterSpan(5,"e"), 
				getLetterSpan(6,"f")
			], 
		};
		var customImg = customImgs();
		diceThemes["Custom"] = {
			type:"Custom",
			content: [
				customImg, 
				customImg, 
				customImg, 
				customImg, 
				customImg, 
				customImg
			],
		};
	}

	self.getThemeOption = function(name) {
		return diceThemes[name];
	};

	self.getImageHTML = function(imageURL) {
		return '<img class="custom" src="' + imageURL + '"">';
	};


	function traditionalSide(sideValue) {
		var src1 = 'img/b' + sideValue + '.png';
		var src2 = 'img/w' + sideValue + '.png';
		return '<img class="traditional-img-b" src="' + src1 + '" >\
			<img class="traditional-img-w" src="' + src2 + '" >';
	}

	function customImgs() {
		var src1 = 'img/custom-pic-b.png';
		var src2 = 'img/custom-pic-w.png';
		return '<img class="custom custom-pic-b" src="' + src1 + '" >\
			<img class="custom custom-pic-w" src="' + src2 + '" >';
	}

	init();
}

function getLetterSpan(side, text){
		return '<span class="letter letter' + side + '" oninput="updateThemeContent('+ side +',this)" onresize="resizeFaceText(this)">' + text + '</span>';
}

function updateThemeContent(side, element){
	theme.content[side-1] = getLetterSpan(side,element.innerHTML);
	resizeFaceText(element);
}

function resizeFaceText(element) {
	if(element == undefined) {
		return 1;
	}
	var jq = $(element);
	var isEmpty = jq.text() === "";
	if(isEmpty) {
		jq.text("a"); //Temporarily set to one char text so meaurements don't get thrown off.
	}
	var fontSize = 150;
	jq.css("font-size", fontSize);
	var max = Math.max(element.scrollHeight / jq.innerHeight(), element.scrollWidth / jq.innerWidth());
	fontSize = 0.9 * fontSize / max;
	jq.css("font-size", fontSize + "px");
	if(isEmpty) {
		jq.text("");
	}
	return fontSize;
}

function resizeAllDiceText(){
	for(var i = 1; i <= 6; i++) {
		var faces = $(".letter"+i);
		var fontSize = resizeFaceText(faces[0]);
		if(faces.length > 0) {
			faces.css("font-size", fontSize+"px");
		}
	}
}