/* Object for converting images passed via flash data to data urls

Vars
	- urls: String[] -- urls to convert to data format. Can pass in falsy elements here
	- onEnd: Function(FlashImgConverter f, String[] newUrls) -- called when done 
*/
function FlashImgConverter(urls, onEnd) {
	//Vars
	var self = this;
	var count = 0;
	var newUrls = [];
	
	//Methods
	function init() {
		newUrls.length = 6;
		for(var i = 0; i < 6; i++) {
			if(urls[i]) {
				count++;
				doConvert(i);
			}
		}
	}

	function doConvert(index) {
		new ImgUrlConverter(urls[index], function(c, newUrl) {
			onConvert(index, newUrl)
		});
	}

	function onConvert(index, newUrl) {
		newUrls[index] = newUrl;
		count--;
		if(count === 0) {
			onEnd(self, newUrls);
		}
	}

	init();
}