//------------------------------------------------------------------------------------
// Dice Widget for SMART Notebook
//    Let's the user spin up to nine customizable dice
// Authors: Francis Ge, Kyle Owsen
//------------------------------------------------------------------------------------

/* 
Notes
	- Images are encoded as data urls, thus all info is kept inside of the widget persistence and memory.
	This make things a bit safer in the case that Notebook accidentally let's go of the resources.
*/
var dice, theme, editMenuIsOpen, currentRgb, colorPicker, diceController, diceThemer, localizedStrings;

(function() {
	// Initialization
	ready = function() {
		if (window.requiresNewerNBSDKVersionError) {
	        var divs = document.body.getElementsByTagName("div");
	        for (var i = 0; i < divs.length; i++) {
	        	divs[i].style.display = "none";
	        }

			var container = window.document.createElement("div");
			container.setAttribute("id", "requiresNewerNBSDKVersionErrorContainer");

	        var p1 = window.document.createElement("p");
	        p1.textContent = NB.localize("This activity requires a later version of SMART Notebook software.");
	        container.appendChild(p1);

	        var p2 = window.document.createElement("p");
	        p2.textContent = NB.localize("Make sure you're using Notebook software version %d or later.").replace("%d", "16");
	        container.appendChild(p2);

	        document.body.appendChild(container);
	        document.body.style.backgroundColor = "lightgray";

	        function adjustHeights(id) {
	        	var elem = document.getElementById(id);
				var fontstep = 2;
				if (elem.offsetHeight > document.documentElement.clientHeight) {
					elem.style.fontSize = ((window.getComputedStyle(elem).fontSize.substr(0,2)-fontstep).toString() + 'px');
					elem.style.lineHeight = (window.getComputedStyle(elem).fontSize.substr(0,2).toString() + 'px');
					adjustHeights(id);
				}
		    }

		    adjustHeights("requiresNewerNBSDKVersionErrorContainer");

	        return;
	    }
	    localizeStrings();
		diceThemer = new DiceThemer();
	    diceController = new DiceController();
    	
    	if(NB.localization.getLocales().ui.isRtl){
    		setRightToLeft();
    	}
		x = diceController;//TODO Remove
	};
	NB.ready(ready);

    function localizeStrings(){
    	localizedStrings = {
		    themes: NB.localize("Themes"),
		    colors: NB.localize("Colors"),
		    traditional: NB.localize("Traditional"),
		    letters: NB.localize("Text"),
		    custom: NB.localize("Custom"),
		    num_dice: NB.localize("Dice"),
		    text_helper: NB.localize("You can add text to each of the six faces."),
		    custom_helper: NB.localize("You can drag images onto each face."),
		};
    	$("#traditional-text").text(" " + localizedStrings.traditional);
    	$("#text-text").html(" " + localizedStrings.letters);
    	$("#custom-text").html(" " + localizedStrings.custom);
    	$("#themes-title").text(localizedStrings.themes);
    	$("#colors-title").text(localizedStrings.colors);
    	$("#num-dice-label").text(localizedStrings.num_dice);
	}

	function setRightToLeft(){
		$(".settings-button").css("text-align","right");
		$(".button-label").css("left","auto").css("right","28%");
		$(".settings-pic").css("left","auto").css("right","8%");
	}

}());


