var NBImageSniffer = function() {

	// Callbacks for when a valid annotation is dragged to a valid location
	var observers;
	var x = 0;
	var y = 0;
	var annotation = null;

	function NBImageSniffer() {
		observers = [];
		initNBObserver();
	}

	// Adds a callback for when a valid annotation is dragged to a valid location
	NBImageSniffer.prototype.addObserver = function(callback) {
		observers.push(callback);
	}

	// Initializes the NB page observer to check for drag and drop events
	function initNBObserver() {
		NB.addObserver("dndDropEvent", function(event) {
			var objects = NB.page.getObjects();
			for(var moved in event.eventData) {
				var object = objects[moved];
				var contact = event.eventData[moved].contact;
				if(isValidType(object) && isValidLocation(contact)) {
					//Get necessary data and perform image conversion
					var widget = NB.getHostObject();
					var xOffset = (widget.width - $(window).width()) / 2;
					var yOffset = (widget.height - $(window).height()) / 2;
					x = contact.x - widget.x - xOffset;
					y = contact.y - widget.y - yOffset;
					annotation = object;
					new ImgUrlConverter(object.getPreview(), onImgConvert)
					break;
				}
			}
		});
	}

	// Checks if the annotation is of a valid type
	function isValidType(object) {
		return object.type !== "widget";
	}

	// Checks if the annotation is dropped to a valid location
	// Note: uses location of the mouse as the object is dropped
	function isValidLocation(contact) {
		var widget = NB.getHostObject();
		return widget.contains(contact.x, contact.y);
	}

	// Calls all registered callbacks with the given data
	function notifyObservers(data) {
		for(var i = 0; i < observers.length; i++) {
			observers[i](data);
		}
	}

	function onImgConvert(converter, url) {
		notifyObservers({
			x: x,
			y: y,
			annotation: annotation,
			img: url,
		});
	}

	return NBImageSniffer;
}();